package com.example.ellegadodepintia.exploradoresDePintia.model.efecto

import com.example.ellegadodepintia.R
import com.example.ellegadodepintia.exploradoresDePintia.model.Atributo
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState.context
import com.example.ellegadodepintia.soundManager.SoundManager


class EfectoResolverTrampaConAtributo(
    probabilidadExito: Int,
    private val atributo: Atributo,
    private val coste: Int,
    private val stringLogrado: String,
    private val stringFallo: String) : Efecto(probabilidadExito) {
    private lateinit var soundManager: SoundManager
    override fun ejecutar(): String {
        soundManager = SoundManager(context!!)
        if (atributo == Atributo.Energia && GameState.jugador.atributos[Atributo.Energia]!!<coste){
            return "No tienes energía suficiente para intentar escapar escalando. Necesitas al menos $coste puntos"
        }else if(atributo == Atributo.Investigacion && GameState.jugador.atributos[Atributo.Investigacion]!!<coste) {
            return "No tienes suficientes puntos de investigación para explorar"
        }else{
            if(atributo==Atributo.Energia){
                soundManager.playSound(R.raw.sound_rocks,100)
            }else if(atributo==Atributo.Vida){
                soundManager.playSound(R.raw.sound_romper,100)
            }
            GameState.jugador.actualizarAtributo(atributo, -coste)
            return if ((1..100).random() <= probabilidadExito){
                GameState.eventoActual.actualizarFinalizado(true)
                stringLogrado
            }else{
                stringFallo
            }
        }

    }
}